# -*- coding:Utf-8 -*-
# rank_cut V.1.103p by DoCky (18/01/2009)
# helped by EmbouT and Nicolous


import es, popuplib

info = es.AddonInfo()
info.author = "DoCky"
info.name = "rank_cut"
info.version = "1.103p"
info.url = "http://addons.eventscripts.com/addons/user/11751"

vers = es.ServerVar(info.name, "", "By DoCky -")
vers.set(info.version)
vers.makepublic()

acces = es.ServerVar("rc_acces")
title = es.ServerVar("rc_title")
empti = es.ServerVar("rc_empti")
playerlist = []

class Joueur(object):
    def __init__(self, steamid, frag, name):
        self.frag = frag
        self.name = name
        self.steamid = steamid

    def __cmp__(self, joueur):
        return cmp(self.frag, joueur.frag)

    def __str__(self):
        return "%s [%s kill]" % (self.name, self.frag)

def load():
    es.server.cmd("es_xmexec ../addons/eventscripts/rank_cut/rank_cut.txt")
    es.regclientcmd(str(acces), "rank_cut/player_rank", "display rank cut menu")
    es.regsaycmd(str(acces), "rank_cut/player_rank", "display rank cut menu")

def unload():
    es.unregclientcmd(str(acces))
    es.unregsaycmd(str(acces))

def player_death(ev):
    controle = False
    for joueur in playerlist:
        if ev["es_attackersteamid"] == joueur.steamid:
            controle = True
            joueur.frag += 1
            break
    if not controle and ev["es_attackersteamid"] != "BOT" and ev["es_attackersteamid"] != "STEAM_ID_PENDING" and ev["es_userteam"] != ev["es_attackerteam"]:
        playerlist.append(Joueur(ev["es_attackersteamid"], 1, ev["es_attackername"]))

def player_rank():
    playerlist.sort(reverse = True)
    rank = []
    for joueur in playerlist: rank.append(str(joueur))
    if not rank: rank = (str(empti),)

    if popuplib.exists("rank_cut"): popuplib.delete("rank_cut")
    rank_cut = popuplib.easylist("rank_cut", rank)
    rank_cut.settitle(str(title))
    rank_cut.send(es.getuserid())
